Loading...
Searching...
No Matches
itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter > Class Template Reference

`#include <itkGPUImageToImageFilter.h>`

## Detailed Description

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>
class itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >

class to abstract the behaviour of the GPU filters.

GPUImageToImageFilter is the GPU version of ImageToImageFilter. This class can accept both CPU and GPU image as input and output, and apply filter accordingly. If GPU is available for use, then GPUGenerateData() is called. Otherwise, GenerateData() in the parent class (i.e., ImageToImageFilter) will be called.

Note
  This file was taken from ITK 4.1.0. It was modified by Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands. Added functionality is described in the Insight Journal paper: http://hdl.handle.net/10380/3393

Definition at line 65 of file itkGPUImageToImageFilter.h.

Inheritance diagram for itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | InputImageConstPointer = typename InputImageType::ConstPointer
using | InputImagePixelType = typename InputImageType::PixelType
using | InputImagePointer = typename InputImageType::Pointer
using | InputImageRegionType = typename InputImageType::RegionType
using | InputImageType = TInputImage
using | OutputImageType = TOutputImage
using | Pointer = SmartPointer<Self>
using | Self = GPUImageToImageFilter
using | Superclass = TParentImageFilter

## Public Member Functions

virtual const char * | GetClassName () const
virtual bool | GetGPUEnabled () const
virtual void | GPUEnabledOff ()
virtual void | GPUEnabledOn ()
void | GraftOutput (const DataObjectIdentifierType &key, DataObject *graft) override
void | GraftOutput (DataObject *graft) override
| ITK_DISALLOW_COPY_AND_MOVE (GPUImageToImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
virtual void | SetGPUEnabled (bool _arg)
void | SetNumberOfWorkUnits (ThreadIdType _arg) override

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

void | GenerateData () override
virtual void | GPUGenerateData ()
| GPUImageToImageFilter ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~GPUImageToImageFilter () override=default

## Protected Attributes

OpenCLKernelManager::Pointer | m_GPUKernelManager {}

## Private Attributes

bool | m_GPUEnabled {}

## Member Typedef Documentation

## ConstPointer

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::ConstPointer = SmartPointer<const Self>

Definition at line 74 of file itkGPUImageToImageFilter.h.

## InputImageConstPointer

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImageConstPointer = typename InputImageType::ConstPointer

Definition at line 90 of file itkGPUImageToImageFilter.h.

## InputImagePixelType

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImagePixelType = typename InputImageType::PixelType

Definition at line 92 of file itkGPUImageToImageFilter.h.

## InputImagePointer

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImagePointer = typename InputImageType::Pointer

Definition at line 89 of file itkGPUImageToImageFilter.h.

## InputImageRegionType

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImageRegionType = typename InputImageType::RegionType

Definition at line 91 of file itkGPUImageToImageFilter.h.

## InputImageType

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::InputImageType = TInputImage

Some convenient typedefs.

Definition at line 88 of file itkGPUImageToImageFilter.h.

## OutputImageType

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::OutputImageType = TOutputImage

Definition at line 93 of file itkGPUImageToImageFilter.h.

## Pointer

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::Pointer = SmartPointer<Self>

Definition at line 73 of file itkGPUImageToImageFilter.h.

## Self

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::Self = GPUImageToImageFilter

Standard class typedefs.

Definition at line 71 of file itkGPUImageToImageFilter.h.

## Superclass

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

using itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::Superclass = TParentImageFilter

Definition at line 72 of file itkGPUImageToImageFilter.h.

## Constructor & Destructor Documentation

## GPUImageToImageFilter()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GPUImageToImageFilter | ( |  | ) |

protected

## ~GPUImageToImageFilter()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::~GPUImageToImageFilter | ( |  | ) |

override protected default

## Member Function Documentation

## GenerateData()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GenerateData | ( |  | ) |

override protected

## GetClassName()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

virtual const char * itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in itk::GPUBSplineDecompositionImageFilter< TInputImage, TOutputImage >, itk::GPUCastImageFilter< TInputImage, TOutputImage >, itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >, itk::GPUInPlaceImageFilter< TInputImage, TOutputImage >, itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, CastImageFilter< TInputImage, TOutputImage > >, itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, InPlaceImageFilter< TInputImage, TOutputImage > >, itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, RecursiveGaussianImageFilter< TInputImage, TOutputImage > >, itk::GPURecursiveGaussianImageFilter< TInputImage, TOutputImage >, itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >, itk::GPUResampleImageFilter< GPUInputImageType, GPUOutputImageType, GPUInterpolatorPrecisionType >, itk::GPUShrinkImageFilter< TInputImage, TOutputImage >, and itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >.

## GetGPUEnabled()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

virtual bool itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GetGPUEnabled | ( |  | ) | const

virtual

## GPUEnabledOff()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

virtual void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GPUEnabledOff | ( |  | ) |

virtual

## GPUEnabledOn()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

virtual void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GPUEnabledOn | ( |  | ) |

virtual

## GPUGenerateData()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

virtual void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GPUGenerateData | ( |  | ) |

inline protected virtual

Reimplemented in itk::GPUBSplineDecompositionImageFilter< TInputImage, TOutputImage >, itk::GPUCastImageFilter< TInputImage, TOutputImage >, itk::GPURecursiveGaussianImageFilter< TInputImage, TOutputImage >, itk::GPUResampleImageFilter< TInputImage, TOutputImage, TInterpolatorPrecisionType, TTransformPrecisionType >, itk::GPUResampleImageFilter< GPUInputImageType, GPUOutputImageType, GPUInterpolatorPrecisionType >, itk::GPUShrinkImageFilter< TInputImage, TOutputImage >, and itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >.

Definition at line 124 of file itkGPUImageToImageFilter.h.

## GraftOutput() [1/2]

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GraftOutput | ( | const DataObjectIdentifierType & | key,
|  | DataObject * | graft )

override

## GraftOutput() [2/2]

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::GraftOutput | ( | DataObject * | graft | ) |

override

## ITK_DISALLOW_COPY_AND_MOVE()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::ITK_DISALLOW_COPY_AND_MOVE | ( | GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter > |  | ) |

## itkStaticConstMacro() [1/2]

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::itkStaticConstMacro | ( | InputImageDimension | ,
|  | unsigned int | ,
|  | TInputImage::ImageDimension | )

ImageDimension constants

## itkStaticConstMacro() [2/2]

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::itkStaticConstMacro | ( | OutputImageDimension | ,
|  | unsigned int | ,
|  | TOutputImage::ImageDimension | )

## New()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

Pointer itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

## SetGPUEnabled()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

virtual void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::SetGPUEnabled | ( | bool | _arg | ) |

virtual

## SetNumberOfWorkUnits()

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

void itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::SetNumberOfWorkUnits | ( | ThreadIdType | _arg | ) |

override

## Field Documentation

## m_GPUEnabled

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

bool itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::m_GPUEnabled {}

private

Definition at line 131 of file itkGPUImageToImageFilter.h.

## m_GPUKernelManager

template<typename TInputImage, typename TOutputImage, typename TParentImageFilter = ImageToImageFilter<TInputImage, TOutputImage>>

OpenCLKernelManager::Pointer itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >::m_GPUKernelManager {}

protected

Definition at line 128 of file itkGPUImageToImageFilter.h.

Generated on 1768596610 for elastix by 1.15.0 |